/*PARAMETERS*/
/**/
#define		MSECONDS	3600
#define     SCREEN      21              /* lines for screen */
#define     MAXPROG     2048      		/* max prog size */
#define     MAXSTACK    BLKSIZ          /* max eval stack */
#define     SYMSIZE     32              /* max symbol length */
#define		SEMICOLON	';'
#define		BLANK		' '
#define		COMMA		','
#define 	EQC     	'='
#define 	DOL     	'$'
#define		HUGE		9999
/**/
/*VARIABLE TYPES*/
/**/
typedef     int         (*INST)();      /* program code */
#define     XSTOP       (INST) 0        /* stop code */
#define     VINT        'i'             /* integer */
#define     VCHAR       'c'             /* character */
#define		VKEY		'k'				/* key number */
#define		VKED		'K'				/* key string */
#define     VSTRING     's'             /* string constant */
#define     VLONG       'l'             /* long */
#define     VFLOAT      'f'             /* float */
#define     VDOUBLE     'd'             /* double */
#define     VFUNC       'x'             /* function */
/**/
/*
**  all variables are represented by pointers; typing
**  takes place in the calling routines by means of
**  casts
**
**  and integer variable (or constant) is produced by
**  a call to malloc for an integer sized area and
**  a call to addsym(name,'i',adr,sizeof(int),elements)
*/
/**/
typedef	char	*	POINTER;	/* data pointer */
/**/
typedef struct  SYMBOL  {       /* symbol table */
    POINTER         adr;        /* pointer to variable */
    POINTER         off;        /* offset for arrays */
    char            *name;      /* variable name */
    char            type;       /* variable type */
    char            esize;      /* size of one element */
    int             tsize;      /* total size */
    struct  SYMBOL  *snext;     /* next symbol */
}   SYMBOL;
/**/
typedef	struct	DATUM	{
	int			vtype;
	union		{
		POINTER     ptr;            /* generic pointer */
		int         ivalu;          /* integer constant */
		long        lvalu;          /* long constant */
		double      dvalu;          /* double constant */
		SYMBOL      *sym;           /* symbol pointer */
	}	v;
}   DATUM;
/**/
/*======================================================================*/
/**/
extern	KARD	*kd;
extern	KBUF	kb;
/**/
#ifdef		ALLOCATE
#define		CRAP	/**/
#else
#define		CRAP	extern
#endif
CRAP int bracket; /* BRACKET COUNTER */
CRAP int cfile;
CRAP char *cfn;
CRAP FILE *cfp;
CRAP int count;
CRAP DATUM dl;
CRAP DATUM dr;
CRAP DATUM ds;
CRAP DATUM es[MAXSTACK]; 	/* evaluation stack */
CRAP DATUM *esu;			/* upper limit for stack */
CRAP DATUM *esx;			/* current stack pointer */
CRAP char *ffn;
CRAP int gargc;
CRAP char **gargv;
CRAP FILE *ifp; /* input file */
CRAP KENV kenv;
CRAP char *kexp; /* expression program */
CRAP int lexlevel; /* LEXICAL LEVEL */
CRAP int linenum; /* line number */
CRAP char *lpx; /* line pointer */
CRAP int ncd;
CRAP int nfile;
CRAP int nsm; /* number of symbols */
CRAP char *ofn;
CRAP FILE *ofp; /* output file */
CRAP INST *prg; /* PROGRAM CODE */
CRAP INST *pru;
CRAP INST *prx;
CRAP DATUM *(*pusher)();
CRAP DATUM rdx;
CRAP char *rfn;
CRAP char *rfu;
CRAP char *rfx;
CRAP SYMBOL *sbase; /* beginning of list */
CRAP SYMBOL *slast; /* last assigned */
CRAP SYMBOL *sym;
CRAP FILE *tfp; /* terminal file pointer */
CRAP int *xbr; /* BREAK SWITCH */
CRAP int *xco; /* CONTINUE SWITCH */
