#define		DEBUG
#undef		DEBUG
#define		memnull(a,b)memset(a,0,b)
/*
**	kacode1.c has compiler phase routines
**	kacode2.c has execution phase routines
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "kawkdefs.h"
/**/
#include	"kawkfunc.h"
/*EXTERN*/
static	INST	lastfunc;
void
segerr(ty)
int		ty;
{
	errmsg("<probable NULL parameter in function call> %s()\n",
		namefunc(lastfunc));
	terror(ty);
}
/**/
void
xstart()        /* INITIALIZE EXECUTION */
{
/*  
**  KERNIGHAN/PIKE, P. 263.
*/
    prx = xecute(prx = prg + 1);
}
xlinenum()      /* save line number */
{
    linenum = (int) *prx++;
    return(linenum);
}
void
xstack()        /* restore stack */
{
    esetr(NULL);
}
void
badcode()
{
	errmsg("xecute <bad code> %u %u %u\n",prx,prx-prg,pru);
	terror(FUBAR);
	return;
}
INST    *
xecute(pg)      /* EXECUTE ONE COMMAND SEQUENCE */
INST	*pg;
{
/*  SET CONTINUE POINTER */
    prx = pg;
#ifdef	DEBUGR
    if(prx < prg || prx >= pru)   badcode();
	if(prx == (INST *) NULL || *prx == XSTOP)	badcode();
#endif
/**/
    while(prx && prx < pru && *prx != XSTOP) {
/**/
#ifdef	DEBUGR
	showcode(prx);
#endif
/**/
#ifdef	DEBUGR
	fprintf(stderr,"xecute(1): prx - prg: %u %lu\n",
		prx - prg, (long) prx);
#endif
        (*(*prx++))();
/**/
#ifdef	DEBUGR
	fprintf(stderr,"xecute(1): prx - prg: %u %lu\n",
		prx - prg, (long) prx);
#endif
    }
/**/
#ifdef	DEBUGR
	fprintf(stderr,"xecute(2): prx(%u) pru(%u)\n",prx,pru);
#endif
    if(prx >= pru)   badcode();
/**/
	return(prx);
}
void
xeval()		/* evaluate a variable on the stack, push the value */
{
    auto    DATUM   d0;
    auto    DATUM   d1;
    d0 = epop();			/* symbol pointer */
    sym = d0.v.sym;			/* easier notation */
#ifdef	DEBUG
fprintf(stderr,"xeval(%s,%d,%c)\n",sym->name,sym->type,sym->type);
#endif	/*DEBUG*/
/**/
    switch(d1.vtype = sym->type)	{
    case    VDOUBLE:    d1.v.dvalu = *((double *) sym->off);
						break;
    case    VSTRING:    d1.v.ptr = sym->off;
						break;
    case    VINT:       d1.v.ivalu = *((int *) sym->off);
						break;
    case    VCHAR:      d1.v.ivalu = *((char *) sym->off);
						break;
	default:			errmsg("xeval <illegal type> %s %c\n",
							sym->name,sym->type);
						terror(FUBAR);
						break;
    }
/**/
#ifdef	DEBUG
fprintf(stderr,"xeval(%s,%u,%u,%u)\n",sym->name,sym->adr,sym->off,d1.v.ivalu);
#endif	/*DEBUG*/
    epush(d1);		/* push the new value */
}
void
xdtoi()		/* double to integer */
{
	ds = epop();
	if(ds.vtype == VDOUBLE)	{
		ds.v.ivalu = (int) ds.v.dvalu;
		ipush(ds);
		}
	else	epush(ds);
}
void
xitod()		/* integer to double */
{
	ds = epop();
	if(ds.vtype == VINT)	{
		ds.v.dvalu = (double) ds.v.ivalu;
		ds.vtype = VDOUBLE;
		epush(ds);
		}
	else	epush(ds);
}
void
xdtol()		/* double to logical integer */
{
#ifdef	SHIT
	ds = epop();
	if(ds.vtype == VDOUBLE)	{
		if(ds.v.dvalu)	ds.v.ivalu = 1;
		else			ds.v.ivalu = 0;
		ipush(ds);
		}
	else	epush(ds);
#endif
}
void
xassgn()
{
    dl = epop();		/* target */
    dr = epop();		/* value to be assigned */
    sym = dl.v.sym;		/* easier notation */
/**/
	if(sym->type == VDOUBLE)	{
		if(dr.vtype == VDOUBLE)	*((double *) sym->off) = dr.v.dvalu;
		else					*((double *) sym->off) = (double) dr.v.ivalu;
		}
	else
	if(sym->type == VCHAR)		{
		if(dr.vtype == VDOUBLE)	*((char *) sym->off) = (char) dr.v.dvalu;
		else					*((char *) sym->off) = (char) dr.v.ivalu;
		}
	else						{
		if(dr.vtype == VDOUBLE)	*((int *) sym->off) = (int) dr.v.dvalu;
		else					*((int *) sym->off) = dr.v.ivalu;
		}
/**/
	dl.v.dvalu = dr.v.dvalu;	/* okay for 8 byte transfer ????? */
	dl.vtype = (int) sym->type;
/**/
#ifdef	DEBUG
fprintf(stderr,"xassgn(%s,%u,%u,%u)\n",sym->name,sym->adr,sym->off,dl.v.ivalu);
#endif	/*DEBUG*/
	epush(dl);
}
void
xconst()		/* push a constant to the stack */
{
    sym = (SYMBOL *) *prx++;
#ifdef	DEBUGR
	fprintf(stderr,"%8.8s ","xconst");
	fprintf(stderr,"esc(%u) ",esx);
	prtasym(stderr,sym);
#endif
	switch(sym->type)	{
		case	VINT:		dr.v.ivalu = *((int *) sym->off);
							break;
		case	VCHAR:		dr.v.ivalu = *((char *) *sym->off);
							break;
		case	VSTRING:	dr.v.ptr = sym->off;
							break;
		case	VDOUBLE:	dr.v.dvalu = *((double *) sym->off);
							break;
		default:			errmsg("xconst <bad type>\n");
							terror(FUBAR);
		}
	dr.vtype = (int) sym->type;
#ifdef	OFF_RESET
	sym->off = sym->adr;
#endif
    epush(dr);
}
void
xkey()				/* push a key to the stack */
{
	auto	int		nk = (int) *prx++;
    ds.v.ptr =    kd[nk].data;
	ds.vtype = VKED;
#ifdef	DEBUGR
	showpush(&ds,"xkey:ds",kd[nk].skey);
#endif
    epush(ds);
}
void
xsym()              /* push symbol from code to stack */
{
    sym = (SYMBOL *) *prx++;
    ds.v.sym = sym;
	ds.vtype = (int) sym->type;
#ifdef	DEBUG
fprintf(stderr,"xsym(%s,%d,%c)\n",sym->name,sym->type,sym->type);
#endif	/*DEBUG*/
    epush(ds);
}
void
xif()
{
    auto    DATUM   ds;             /* must be local */
    auto    INST    *p0;
    auto    INST    *p1;
    auto    INST    *p2;
    auto    INST    *p3;
    auto    INST    *p4;
    p0 = prx++;
    p1 = prx++;
    p2 = prx++;
    p3 = prx++;
    p4 = prx++;
    xecute((INST *) *p0);
    ds = epop();
    if(ds.v.ivalu)	xecute((INST *) *p1);
    else
    if(*p2 != *p3)	xecute((INST *) *p2);
    prx = prx ? (INST *) *p3 : prx;
}
void
xwhile()
{
    auto    DATUM   ds;             /* must be local */
    auto    int     zbr = 1;        /* LOCAL BREAK VAR */
    auto    int     *pbr;    		/* PREVIOUS BREAK */
    auto    INST    *p0;
    auto    INST    *p1;
    auto    INST    *p2;
/*
**  code[0] test expression
**  code[1] executable statement
**  code[2] next code
*/
/*  SET BREAK/CONTINUE SWITCH */
    pbr = xbr;
    xbr = &zbr;
    p0 = prx++;
    p1 = prx++;
    p2 = prx++;
    xecute((INST *) *p0);			/* test code */
    ds = epop();
    while(ds.v.ivalu )    	{
        xecute((INST *) *p1);		/* body code */
		if(!zbr)	break;			/* break called */
        xecute((INST *) *p0);		/* test code */
        ds = epop();
        }
/*  RESET BREAK SWITCH */
    xbr = pbr;
    prx = (INST *) *p2;
}
void
xfor()
{
    auto    DATUM   ds;             /* must be local */
    auto    int     zbr = 1;
    auto    int     *pbr;
    auto    INST    *p0;
    auto    INST    *p1;
    auto    INST    *p2;
    auto    INST    *p3;
    auto    INST    *p4;
/*
**  CODE[0]     EXPR1
**  CODE[1]     EXPR2
**  CODE[2]     EXPR3
**  CODE[3]     STATEMENT
**  CODE[4]     NEXT CODE
*/
/*  SET BREAK SWITCH */
    pbr = xbr;
    xbr = &zbr;
    p0 = prx++;
    p1 = prx++;
    p2 = prx++;
    p3 = prx++;
    p4 = prx++;
    xecute((INST *) *p0);    /* EXPR 1 */
    xecute((INST *) *p1);    /* EXPR 2 */
    ds = epop();
    while(ds.v.ivalu )    {
        xecute((INST *) *p3);	/* executable statement */
		if(!zbr)	break;		/* break called */
        xecute((INST *) *p2);	/* post action expression */
        xecute((INST *) *p1);	/* test condition */
        ds = epop();
        }
/*  RESET BREAK SWITCH */
    xbr = pbr;
    prx = (INST *) *p4;
}
void
xland()
{
    auto    DATUM   ds;         /* must be local */
    auto    INST    *p0;
    auto    INST    *p1;
    p0 = prx++;
    p1 = prx++;
    ds = epop();
    if(ds.v.ivalu)  xecute(p1);
    else            epush(ds);
    prx = (INST *) *p0;
}
void
tyfubar(is)
char	*is;
{
	errmsg("<non-integer operand> '%s'\n",is);
	terror(FUBAR);
}
void
xbwright()	/* >> right shift */
{
	dr = epop();
	ds = epop();
	if(dr.vtype != VINT || ds.vtype != VINT)	tyfubar(">>");
	dl.v.ivalu = ds.v.ivalu >> dr.v.ivalu;
	dl.vtype = VINT;
	epush(dl);
}
void
xbwleft()	/* << left shift */
{
	dr = epop();
	ds = epop();
	if(dr.vtype != VINT || ds.vtype != VINT)	tyfubar("<<");
	dl.v.ivalu = ds.v.ivalu << dr.v.ivalu;
	dl.vtype = VINT;
	epush(dl);
}
void
xbwand()	/* & or */
{
	dr = epop();
	ds = epop();
	if(dr.vtype != VINT || ds.vtype != VINT)	tyfubar("&");
	dl.v.ivalu = ds.v.ivalu & dr.v.ivalu;
	dl.vtype = VINT;
	epush(dl);
}
void
xbwxo()		/* ^ or */
{
	dr = epop();
	ds = epop();
	if(dr.vtype != VINT || ds.vtype != VINT)	tyfubar("^");
	dl.v.ivalu = ds.v.ivalu ^ dr.v.ivalu;
	dl.vtype = VINT;
	epush(dl);
}
void
xonec()		/* ~ ones complement */
{
	dr = epop();
	if(dr.vtype != VINT)	tyfubar("~");
	dl.v.ivalu = ~dr.v.ivalu;
	dl.vtype = VINT;
	epush(dl);
}
void
xbwio()		/* | or */
{
	dr = epop();
	ds = epop();
	if(dr.vtype != VINT || ds.vtype != VINT)	tyfubar("|");
	dl.v.ivalu = ds.v.ivalu | dr.v.ivalu;
	dl.vtype = VINT;
	epush(dl);
}
void
xlor()
{
    auto    DATUM   ds;         /* must be local */
    auto    INST    *p0;
    auto    INST    *p1;
    p0 = prx++;
    p1 = prx++;
    ds = epop();
/*	POSSIBLE MIXED MODE PROGLEM */
    if(!ds.v.ivalu) xecute(p1);
    else            epush(ds);
    prx = (INST *) *p0;
}
void
xfunc()         /* EXECUTE A FUNCTION */
{
    auto    DATUM   *dsx;        /* stack pointer */
    auto    INST    *next;       /* next code */
    auto    INST    func;        /* function to call */
    auto    int     narg;        /* num args */
/**/
    lastfunc = func = *prx++;
    narg = (int) *prx++;
    next = (INST *) *prx++;
/**/
    dsx = esx;
/*  PUT FUNCTION PARAMETERS ON STACK */
    if(*prx != XSTOP)	{
		xecute(prx);
		}
/*  EXECUTE THE FUNCTION */
    (*func)(narg,dsx);
	if(pusher != (FUNCP) NULL)	(*pusher)(rdx);
	pusher = (FUNCP) NULL;
/*
**  FUNCTION (BUILTIN) WILL HAVE LEFT VALUE ON
**  TOP OF STACK; GET THIS VALUE; RESET STACK;
**  THEN PUSH THIS VALUE
*/
    dr = epop();
    esx = dsx;
    epush(dr);
/*  NEXT CODE */
    prx = prx ? next : prx;
}
void
xbreak()        /* execute break code */
{
    if(xbr == NULL) {
        errmsg("xbreak <break error>\n");
        terror(FUBAR);
        }
/*
	break has two tasks: 
	(a) stop execution of the current statement.  this is done by
	setting prx to NULL.
	(b)	stopping execution of the loop containing the break
	statement.  this is done by setting a switch variable to 0.
*/
    prx = NULL;	/* stop execution */
    *xbr = 0;	/* break loop */
}
void
xcontinue()
{
    prx = NULL;
}
void
xswap()		/* swap for subscripts with assignment */
{
	auto	DATUM	d0;
	auto	DATUM	d1;
	d0 = epop();	/* subscript code */
	d1 = epop();	/* right side of assignment */
#ifdef	DEBUG
fprintf(stderr,"d0 %d d1 %d\n",d0.v.ivalu,d1.v.ivalu);
#endif	/*DEBUG*/
	epush(d0);
	epush(d1);
}
void
xarray()    /* Calculate subscript */
{
	auto	SYMBOL	*sym;
    auto    DATUM   d0;		/* symbol */
	auto	DATUM	d1;		/* calculated subscript */
/**/
	d0 = epop();		/* the symbol */
	sym = d0.v.sym;
	d1 = epop();		/* the offset */
    sym->off = sym->adr + (d1.v.ivalu * sym->esize);
#ifdef	DEBUG
fprintf(stderr,"xarray(%s,%u,%u,%d)\n",sym->name,sym->adr,sym->off,d1.v.ivalu);
#endif	/*DEBUG*/
/**/
	epush(d0);			/* symbol with reset offset */
/**/
}
void
xpoint()        /* push pointer to stack */
{
/* array used as a simple variable */
    dr = epop();
    sym = dr.v.sym;
    dr.v.ptr = sym->adr;
	dr.vtype = (int) sym->type;
#ifdef	DEBUG
fprintf(stderr,"xpoint(%s,%d,%c)\n",sym->name,sym->type,sym->type);
#endif	/*DEBUG*/
    epush(dr);
}
#ifdef	DEBUGR
showpush(dl,os,is)
DATUM	*dl;
char	*os;
char	*is;
{
	if(os)	fprintf(stderr,"%s ",os);
	if(is)	fprintf(stderr,"%s ",is);
	switch(dl->vtype)	{
		case	'c':	
			fprintf(stderr,"%c %o",dl->vtype,dl->v.ivalu);
		when	'd':	
			fprintf(stderr,"%c %d",dl->vtype,dl->v.dvalu);
		when	'i':	
			fprintf(stderr,"%c %d",dl->vtype,dl->v.ivalu);
		when	's':	
			fprintf(stderr,"%c %u %s",dl->vtype,dl->v.ptr,dl->v.ptr);
		when	VKED:	
			fprintf(stderr,"%c %u %s",dl->vtype,dl->v.ptr,dl->v.ptr);
						break;
		default:		fprintf(stderr,"?");
		}
	fprintf(stderr,"\n");
}
#endif
