#define		DEBUG
#undef		DEBUG
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"keyproto.h"
#include	"kawkfunc.h"
/**/
/*EXTERN*/
FILE	*rfp;
void
kxtocd(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = cdtox(ap[0].v.ptr,ap[1].v.ivalu);
	pusher = ipush;
}
void
kcdtox(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = cdtox(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu-1);
	pusher = ipush;
}
void
knextkey(na,ap)
int		na;
DATUM	*ap;
{
	static	int		nk = ZERO;
	auto	int		ty = ap[0].v.ivalu;
/**/
/**/
	pusher = spush;		/* most common case */
/**/
	if(ty == 0)	{
		rdx.v.ivalu = nk = ZERO;
		pusher = ipush;
		return;
		}
	else
	if(ty == 1)	{
		rdx.v.ptr = NULL;
		while(nk < kb.nfld)
			if(!isnull(kd[nk].data))	{
				rdx.v.ptr = kd[nk].data;
				nk += 1;	/* advance one for next time */
				break;
				}
			else	nk += 1;
		return;
		}
/**/
	if(nk <= 0 || nk > kb.nfld)	{
		errmsg("nextkey <invalid call>\n");
		terror(FUBAR);
		}
/**/
	if(ty == 2)	{
		rdx.v.ivalu = nk - 1;
		pusher = ipush;
		}
	else
	if(ty == 3)	{
		rdx.v.ptr = kd[nk - 1].skey;
		}
	else
	if(ty == 4)	{
		rdx.v.ptr = kd[nk - 1].lkey;
		}
	else
	if(ty == 5)	{
		rdx.v.ptr = kd[nk - 1].label;
		}
	return;
}
void
kkeycnt(na,ap)
int na;
DATUM   *ap;
{
    REG int ix;
    REG int nk;
    for(ix = nk = 0; ix < nk; ix++) 
        if(!isnull(kd[nk].data))    nk += 1;
    rdx.v.ivalu = nk;
    pusher = ipush;
}
void
kiskey(na,ap)
int na;
DATUM   *ap;
{
    rdx.v.ivalu = iskey(ap[0].v.ptr);
    pusher = ipush;
}
void
kcdsize(na,ap)
int na;
DATUM   *ap;
{
    rdx.v.ivalu = cdsize();
    pusher = ipush;
}
void
kcdcond(na,ap)
int na;
DATUM   *ap;
{
    cdcond();
    rdx.v.ivalu = 0;
    pusher = ipush;
}
void
kwrcard(na,ap)          /* write a card */
int     na;
DATUM   *ap;
{
/**/
	auto	FILE	*fp = (na == 1) ? (FILE *) ap[0].v.ivalu : ofp;
	auto	int		ty = isatty(fileno(fp)) ? 'f' : 'w';
/**/
	rdx.v.ivalu = (int) wrcd(fp,ty,kenv.folder);
/**/
    pusher = ipush;
}
void
krdcard(na,ap)          /* read a card */
int     na;
DATUM   *ap;
{
/*
	rdcard()
	rdcard(file_pointer);
*/
    auto    char    *err;
/**/
    if(!kenv.keying)    {
        errmsg("rdcard <file not keyed>\n");
        terror(FUBAR);
        }
/**/
	clcd();
/**/
	if(na == 0)	{
		while((int) (rfp = getfile()))	{
			rdx.v.ptr = 	(POINTER) rdcd( rfp ,'v');
			if(rdx.v.ivalu)	break;
			else
			if(xrderr())	break;
			else
			if(rderr(NULL))	break;
			else			continue;
			}
		}
	if(na == 1)	{
		rdx.v.ptr = (POINTER) rdcd( (FILE *) ap[0].v.ivalu,'v');
		}
/**/
	if(!rdx.v.ptr)	{
		if((int)(err = rderr(NULL)))	{
            errmsg("rdcard <key duplicated or unknown> '%s'\n",err);
            wrcd(stderr,'f',56);
            terror(FUBAR);
			}
		}
	count += 1;
/**/
    pusher = ipush;
}
void
kxrdcd(na,ap)         /* read a card */
int     na;
DATUM   *ap;
{
	auto	char	*os = ap[0].v.ptr;
	auto	char	*us = os + ap[1].v.ivalu;
/*
	xrdcd(buf,size_of_buf);
	xrdcd(buf,size_of_buf,file_pointer);
*/
	if(na == 2)	{
			while((int)(rfp = getfile()))	{
				rdx.v.ptr = 	(POINTER) xrdcd(os,us,rfp);
				if(rdx.v.ptr)	break;
				else
				if(xrderr())	break;
				else			continue;
				}
		}
	else
	if(na == 3)	{
		rdx.v.ptr = (POINTER) xrdcd(os,us, (FILE *) ap[2].v.ivalu);
		}
	pusher = spush;
}
void
kxwrcd(na,ap)         /* write a card */
int     na;
DATUM   *ap;
{
    auto    int     isterm = isatty(fileno(ofp));
    if(isterm)  rdx.v.ptr = xwrcdf(ap[0].v.ptr,ofp,kenv.folder,NULL);
    else        rdx.v.ptr = xwrcd(ap[0].v.ptr,ofp);
    pusher = spush;
}
void
kkeyzap(na,ap)	/* delete one or more keys; free space */
int		na;
DATUM	*ap;
{
    auto    int     nk;
	auto	int		i;
	for(i = 0; i < na; i++)	{
		if((nk = badkey(ap[i].v.ptr)) < 0)	terror(FUBAR);
		kd[nk].data = free_if(kd[nk].data);
		}
	rdx.v.ptr = NULL;
	pusher = spush;
}
void
kkeycat(na,ap)
int     na;
DATUM   *ap;
{
	keyglue(1,na,ap);
}
void
kkeytac(na,ap)
int     na;
DATUM   *ap;
{
	keyglue(2,na,ap);
}
void
keyglue(ty,na,ap)
NOSIGN	ty;
int	na;
DATUM	*ap;
{
	auto	int		nk = badkey(ap[0].v.ptr);
	auto	char	*ss = (na == 3) ? ap[2].v.ptr : " ";
	if(nk < 0)	{
		terror(FUBAR);
		}
	if(ty == 1)	{
		rdx.v.ptr = keyjoin(kd[nk].data, ss, ap[1].v.ptr);
		}
	else
	if(ty == 2)	{
		rdx.v.ptr = keyjoin(ap[1].v.ptr, ss, kd[nk].data);
		}
	kd[nk].data = free_if(kd[nk].data);
	kd[nk].data = rdx.v.ptr;
	pusher = spush;
}
char	*
keyjoin(ls,ss,rs)
char	*ls;
char	*ss;
char	*rs;
{
	auto	char	*osx = kb.base;
	auto	char	*usx = kb.bmax;
	if(!isnull(ls)) osx = strkat(osx,usx,ls);
	if(!isnull(ss)) osx = strkat(osx,usx,ss);
	if(!isnull(rs)) osx = strkat(osx,usx,rs);
	if(osx >= usx)	{
		errmsg("keyjoin <overflow>\n");
		terror(FUBAR);
		}
	return(strsave(kb.base));
}
void
klsrdcd(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ptr = lsrdcd(ap[0].v.ptr,ZERO,FUBAR);
	pusher = spush;
}
void
kclcard(na,ap)
int		na;
DATUM	*ap;
{
	clcd();
	rdx.v.ivalu = 0;
	pusher = ipush;
}
