/*
**  string and substring maninpulation routines for kawk
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/*EXTERN*/
/**/
#ifndef	__MEDIUM__
void
kcindex(na,ap)      /* character position */
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strchr(ap[0].v.ptr,ap[1].v.ivalu);
    if(rdx.v.ptr)  rdx.v.ivalu = rdx.v.ptr - ap[0].v.ptr + 1;
    else        rdx.v.ivalu = -1;
	pusher = ipush;
}
void
kcrindex(na,ap)     /* character position (last) */
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strrchr(ap[0].v.ptr,ap[1].v.ivalu);
    if(rdx.v.ptr)  rdx.v.ivalu = rdx.v.ptr - ap[0].v.ptr + 1;
    else        rdx.v.ivalu = -1;
	pusher = spush;
}
void
ktranspose(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = transpose(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ivalu);
	pusher = spush;
}
char    *
transpose(is,ps,nc) /* transpose nc-th occurence of ps marked is */
char    *is;
char    *ps;
NOSIGN	nc;
{
    register    char    *isx = is;
    auto        int     lp = strlen(ps);
    if(isnull(is))      return(is);
    nc = nc >= 1 ? nc : 1;
    while(nc >= 1 && *isx != ZERO)
    if(*isx == ps[0] && strncmp(isx,ps,lp) == 0)    {
            nc -= 1;
            if(nc == 0) {
                strnrev(isx,lp);
                strnrev(is,isx-is);
                strnrev(is,(isx+lp)-is);
                strrev(isx+lp);
                strnrev(is,(isx+lp)-is);
                strrev(is);
                return(is);
                }
            else    isx += lp;
            }
    else    isx += 1;
    return(is);
}
#else
void
kcrindex(na,ap)
int		na;
DATUM	*ap;
{
	notimp("crindex");
}
void
kcindex(na,ap)
int		na;
DATUM	*ap;
{
	notimp("cindex");
}
void
ktranspose(na,ap)
int		na;
DATUM	*ap;
{
	notimp("transpose");
}
#endif	__MEDIUM__
/**/
void
kstrget(na,ap)		/* sscanf function */
int		na;
DATUM	*ap;
{
	
	auto	char	*osx = ap[0].v.ptr;
	auto	char	*usx = ap[0].v.ptr + ap[1].v.ivalu;
	rdx.v.ptr = strget(osx,usx,ap[2].v.ptr,ap[3].v.ptr);
	pusher = ipush;
}
void
kbshpat(na,ap)		/* bourne shell pattern matching */
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = (int) bshpat(ap[0].v.ptr,ap[1].v.ptr);
	pusher = ipush;
}
void
compile(na,ap)		/* compile from a file */
int		na;
DATUM	*ap;
{
	rdx.v.ptr = formexec(ap[0].v.ptr,NULL);
	pusher = ipush;
}
void
kchrcnt(na,ap)      /* character count */
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = strcnt(ap[0].v.ptr,ap[1].v.ivalu);
	pusher = ipush;
}
void
kstrfold(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strfold(ap[0].v.ptr,ap[1].v.ivalu);
	pusher = spush;
}
void
kstrsave(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strsave(ap[0].v.ptr);
	pusher = spush;
}
void
kstrfree(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = free_if(ap[0].v.ptr);
	pusher = spush;
}
void
ktoalnum(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ptr = toalnum(ap[0].v.ptr);
	pusher = spush;
}
char	*
toalnum(is)
char	*is;
{
	register	char	*isx = is;
	register	char	*osx = is;
	while(*isx != ZERO)	
	if(isalnum(*isx))	*osx++ = *isx++;
	else
	if(isspace(*isx))	{
		*osx++ = ' ';
		while(isspace(*isx))	++isx;
		}
	else						++isx;
	*osx = ZERO;
	return(is);
}
void
kcapital(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = capital(ap[0].v.ptr);
	pusher = spush;
}
char    *
capital(is)     /* capitalize first letters of words */
char    *is;
{
    REG     char    *isx = is;
    while(isspace(*isx))    ++isx;
    if(islower(*isx))       *isx = toupper(*isx);
    while(*isx != ZERO)
	if( (isspace(*isx) || *isx == '(' || *isx == '[' || *isx == '"' ||
		*isx == '\'') && islower(isx[1]))    {
        isx[1] = toupper(isx[1]);
        isx += 2;
        }
    else    isx += 1;
    return(is);
}
#ifdef	__MEDIUM__
words(is)
char    *is;
{
    REG     char    *isx = is;
    REG     int     wc = 0;
    while(isspace(*isx))    ++isx;
    while(*isx != ZERO) {
    if(isspace(*isx))   ++isx;
    else    {
        wc += 1;
        while(*isx != ZERO && !isspace(*isx))   ++isx;
        }
    }
    return(wc);
}
void
kwords(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = words(ap[0].v.ptr);
	pusher = ipush;
}
#else
void
kwords(na,ap)
int		na;
DATUM	*ap;
{
	notimp("words");
}
#endif	__MEDIUM__
