#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"keyproto.h"
#define		NXP		4
#define		TAR		0
#define		REP		1
#define		FLG		2
#define		BIG		9999
#define		ONE		1
static	char	*xp[NXP];
static	int		gl;
static	int		bl;
/*EXTERN*/
#ifdef	CAN_PROTO
extern char *re_comp(char *);
extern char *rex_errs(int);
#else
extern char *re_comp();
extern char *rex_errs();
#endif
/**/
dochg(n1,n2,is)         /* call edcd; process results */
int	n1;
int	n2;
char    *is;
{
	auto	int   del = 0;    /* local change indicator */
	auto	int	nc;
	auto	int	i;
	if(*is == 'c')  ++is;
	if(*is == '/')  ++is;
	if(*is == '<')	++is;
/*
	depending on return from edcard, a new card
	is written to the buffer or one removed from
	it
	on entry, the screen is cleared if a global is
	not in effect
*/
	if(kenv.leisur & DA && cdx.glb == NO)	scr_cl(stdout);
	for(i = n1; i <= n2; i++) {
		cdx.cur = i;
		nc = edcard(is,i);
		del = (cdx.del >= 1) ? (del + 1) : del;
/*
*/
		switch(nc)  {
		case	'E':	errmsg("dochg <bad card> %d\n",cdx.cur);
		case    'Q':    if(del) undo(BWRT,"dochg");
						terror(FUBAR);
						break;
		case	'C':	break;
		case    'x':
		case    'q':    break;
		case    'D': 	clcd();
						break;
		default:        errmsg("<edcard?> %c\n",nc);
						break;
		}
		if(cdx.del) {
			if(nullcd()) {
				delcd(i,i,"");
				n2 -= 1;
				i = i >= 1 ? --i : i;
			}
			else    {
			if(!chgcd(i,CARD_IO))	break;
			}
		}
	}
	if(cdx.del) cdx.chg = 1;
/*
**	on exit, the screen is updated if there was a change
**	and a global is not in effect
*/
	if(kenv.leisur & DA && cdx.glb == NO && cdx.chg)	{
		prlist(cdx.cur,cdx.cur,"Z");
		}
	cdx.con = YES;
	return(ZERO);
}
/**/
delcd(n1,n2,is)         /* Software, p. 198. */
int		n1;
int		n2;
char	*is;
{
	moveblk(n1,n2,cdx.lst);
	cdx.lst = cdx.lst - (n2 - n1 + 1);
	if(cdx.lst <= 0)    {
		printff("\007 no cards left\n");
		cdx.cur = 0;
		return(cdx.con = NO);
		}
	else
	if(cdx.lst <= 1)    {
		cdx.cur = 1;
		printff("\007 one card left\n");
		}
	else    {
		cdx.act = 2;
		cdx.nn1 = cdx.nn2 = cdx.cur = n1;
		}
	cdx.del = cdx.chg = YES;
	prlist(cdx.cur,cdx.cur,is);
	return(cdx.con = YES);
}
/**/
subparse(is,ef,xp,nxp,gl,bl)
char	*is;		/* str to parse */
FUNCP	ef;			/* err function */
char	*xp[];		/* parse sub string */
int		nxp;		/* elements in xp */
int		*gl;		/* global flag */
int		*bl;		/* beg line flag */
{
	auto	char	ws[FNMSIZ];
	auto	char	*isx;
	auto	int		rn;
/**/
	strkat(ws, ws + FNMSIZ - 1, is);
	if(*is == 's')	isx = is + 1;
	else
	if(*is == 'S')	isx = is + 1;
	else			isx = is;
/**/
	xesc(isx);
/**/
	if(splitc(xp,nxp,isx,isx[0]) != 3) 	{
		errmsg("<bad syntax> '%s'\n",ws);
		if(ef != (FUNCP) NULL)	fubar(FUBAR);
		else					return(FUBAR);
		}
/**/
	*gl = (*(xp[FLG]) == 'g') ? BIG : ONE;
/**/
	*bl = (*(xp[TAR]) == '^') ? ONE : ZERO;
/**/
	if((rn = (int) re_comp(xp[TAR])))	{
		errmsg("<bad pattern> '%s'\n",rex_errs(rn));
		if(ef != (FUNCP) NULL)	fubar(FUBAR);
		else					return(FUBAR);
		}
	return(ZERO);
}
kdosub(n1,n2,is)
int		n1;
int		n2;
char    *is;
{
	auto	int   ns = 0;
	auto	int  	i = 0;
/**/
	subparse(is,(FUNCP) terror,xp,NXP,&gl,&bl);
/**/
/*
**  note that this routine works on each card as long
**  string with embedded line feeds
*/
	for(i = n1; i <= n2; i++) {
	cdx.cur = i;
	kb.used = kb.base;
	getcd(i,LINE_IO);
	ns = dsub(kb.used,kb.bmax,kb.base,xp[1],gl,0);
	if(ns < 0)              {
		errmsg("<kdosub: insufficient core>\n");
		cdx.con = NO;
		break;
		}
	else
	if(ns == 0) {
		if(cdx.glb == NO) errmsg("<no match>\n");
		}
	else
	if(ns >= 1) {
			strcpy(kb.base,kb.used);
			cdx.del += 1;
			cdx.chg = 1;
			if(strlen(kb.base) <= 0)    {
				delcd(i,i,"");
				cdx.nn2 -= 1;
			}
			else    {
			if(!chgcd(i,LINE_IO))	break;
			prlist(i,i,xp[2]);
			}
		}   /* end of if */
	}   /* end of for loop */
	return(ZERO);
}
/**/
moveit(n1,n2,n3)    /* Software, p. 199. */
int		n1;
int		n2;
int		n3;
{
	cdx.con = YES;
	cdx.del = NO;
	if(n1 <= 0 || (n3 >= n1 && n3 < n2)) {
		errmsg("<illegal address for move>\n");
		terror(FUBAR);
		}
/**/
	moveblk(n1,n2,n3);
/**/
	if(n3 > n1) cdx.cur = n3;
	else        cdx.cur = n3 + (n2 - n1 + 1);
	cdx.chg = cdx.del = YES;
/**/
	return(cdx.con);
}
/**/
copyit(n1,n2,n3)
int		n1;
int		n2;
int		n3;
{
	REG	    int 	i;
	auto	int   need=0;
	auto	int	last=0;
	cdx.del = NO;
	need = n2 -n1 +1;
	if(n1 <= 0 || (n3 >= n1 && n3 < n2)) {
		errmsg("<illegal address for move>\n");
		terror(FUBAR);
		}
	if( (n2 + need) >= cdx.max) {
		errmsg("<too many cards>\n");
		terror(FUBAR);
		}
	last = cdx.cur = cdx.lst;
	for(i = n1; i <= n2; i++) {
		getcd(i,LINE_IO);
		if(!putcd(LINE_IO))	break;
		}
	moveit(last+1,cdx.lst,n3);
	cdx.del = cdx.chg = YES;
	cdx.nn1 = cdx.nn2 = cdx.cur = n3 + 1;
	cdx.act = 2;
	return(cdx.con=YES);
}
