#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/*
*/
#define			XLINE	0		/* text line */
#define			TLINE	1		/* table line */
#define			BLINE	2		/* border line */
#define         TCOLS   32      /* number of columns */
/*EXTERNAL*/
/*STATIC*/
static  char    *dp[TCOLS];     /* data */
static	char	*tf;		/* format */
static  int     td = '%';       /* delineator */
static  int     fw;             /* field width */
static  int     fl;             /* field limit */
static  int     nd = 0;         /* n-th data item */
static  int     pc = ' ';       /* pad character */
/*
*/
pws(is)                     /* printing width of string */
char    *is;
{
	REG     unsigned	char    *isx = is;
	REG     			int     pwx = 0;
	while(*isx != ZERO) {
	if(*isx == WORD)    {
		isx += 2;
		}
	else    {
		pwx += pwc(*isx);
		*isx++;
		}
	}
	return(pwx);
}
/*
*/
xth(nv,is)					/* table hint */
char	*is;
{
	tblwrt(nv,".ts        table on");
	tblwrt(nv,".te        table off");
	tblwrt(nv,".td        table column delineator (%)");
	tblwrt(nv,".tf string format for table");
	tblwrt(nv,"\%nn.mm[lcrd]");
	tblwrt(nv,"nn         field width");
	tblwrt(nv,"mm         max width or decimal position");
	tblwrt(nv,"l          left justified");
	tblwrt(nv,"r          right justified");
	tblwrt(nv,"c          centered");
	tblwrt(nv,"d          decimal");
	return(0);
}
xlj(nv,is)                  /* left justify a string */
char    *is;
{
	auto    char    os[BLKSIZ];
	auto    char    *osx;
	auto    int     fw;
	auto    int     ls;
	auto    char    *xp[5];
/*
**  expect problems with expansions
*/
/*
**  .lj [ets] string width name
*/
	savecmd(is);
	getqs(xp,5,is);
	fw = setvar(nv,xp[2],HORZ,0,x[nv].px);
	ls = pws(xp[2]);
	fw = fw < ls ? ls : fw;
	osx = lstr(os,os+BLKSIZ-1,xp[1],fw,0,ZSP);
	*osx++ = ITP;
	*osx = ZERO;
	switch(*xp[0])  {
	case    'e':    fputut(os,stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(xp[3],os,'$');
					break;
	case    't':
	default:        isolate(nv,os,1);
					break;
	}
	return(0);
}
xrj(nv,is)                  /* right justify a string */
char    *is;
{
	auto    char    os[BLKSIZ];
	auto    int     fw;
	auto    char    *xp[5];
/*
**  expect problems with expansions
*/
/*
**  .rj [ets] string width name
*/
	savecmd(is);
	getqs(xp,5,is);
	fw = setvar(nv,xp[2],HORZ,0,x[nv].px);
	rstr(os,os+BLKSIZ-1,xp[1],fw,fw,ZSP);
	switch(*xp[0])  {
	case    'e':    fputut(os,stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(xp[3],os,'$');
					break;
	case    't':
	default:        isolate(nv,os,1);
					break;
	}
	return(0);
}
xte(nv,is)					/* table off */
char	*is;
{
	return(xts(nv,"n"));
}
xts(nv,is)					/* table on */
char	*is;
{
	if(x[nv].br >= 1 && x[nv].osx > x[nv].os)	xbr(nv,is);
	x[nv].br = 0;
	return(x[nv].tf = setvar(nv,is,ABSO,x[nv].tf,1));
}
xtf(nv,is)                  /* table format */
char    *is;
{
	if(isnull(is))      return(x[nv].tf = 0);
	while(isspace(*is)) ++is;
	if(*is == '\\')     tf = stringer(is+1,tf);
	else                tf = stringer(is,tf);
	x[nv].ce = 0;
	return(x[nv].tf = 1);
}
xtd(nv,is)                  /* table delineator */
char    *is;
{
	while(isspace(*is)) ++is;
	if(*is == '\\') td = *++is;
	else
	if(*is == ZERO) td = '%';
	else            td = *is;
	return(td);
}
ztb(nv,is)                  /* write table line */
char    *is;
{
	auto	int		ls = x[nv].ls;	/* save line spacing */
	auto	int     nr = 0;			/* 1 = table, 0 = text */
	auto	char	*isx = is;
	x[nv].ls = 1;
	while(isfont(*isx))		++isx;
	nr = ztb1(nv,isx);
	if(nr == BLINE)	{ tblwrt(nv,is); }
	else
	if(nr == TLINE)	{
		tblwrt(nv,is);
		if(ls > 1)    {
			REG int sp = ls - 1;
			while(sp-- >= 1)    {
				strcpy(is,"%%%%%%%%%%%%%%%%");
				ztb1(nv,is);
				tblwrt(nv,is);
				}
			}
		}
	x[nv].ls = ls;
	return(nr);
}
ztb1(nv,is)                 /* process is according to tf */
char    *is;
{
	auto    char    ws[BLKSIZ];     /* work */
	auto    char    *wsx = ws;
	auto    char    *wsu = ws + BLKSIZ - 1;
	REG     char    *tfx = tf;      /* format */
	auto    int     np;             /* num data items */
	auto    int     lc = '_';      	/* horz line char */
	auto	int		nr = XLINE;
	auto	int		ni = x[nv].in + x[nv].ti;
/*  CTEXT:
**
**  when using static to cut overhead, must remember to
**  initialize each time
**
*/
	nd = 0;                         /* n-th data item */
/*  draw horizontal line */
	if(is[1] == ZERO)   {
		np = TCOLS;
		while(--np >= 0)    dp[np] = "";
		lc = is[0];
		nr = BLINE;
		}
	else
	if(*is != td)   return(XLINE);
	else	{
		nr = TLINE;
		np = splitc(dp,TCOLS,is,*is);
		}
/*
*/
	while(*tfx != ZERO)
	if(*tfx == '\\' && tfx[1] == td)    {
		*wsx++ = td;
		tfx += 2;
		}
	else
	if(*tfx == td)  {
		tfx += 1;
		if(*tfx == '0' ||
			ispunct(*tfx))          pc = *tfx++;
		else                        pc = ' ';
		fw = fl = 0;
		if(isdigit(*tfx))           fl = fw = atoi(tfx);
		while(isdigit(*tfx))        ++tfx;
		if(*tfx == '.') {
			tfx += 1;
			if(isdigit(*tfx))       fl = atoi(tfx);
			while(isdigit(*tfx))    ++tfx;
		}
		switch(*tfx)    {
		case    'l':    wsx = lstr(wsx,wsu,dp[nd++],fw,fl,pc);
		when    'c':    wsx = cstr(wsx,wsu,dp[nd++],fw,fl,pc);
		when    'd':    wsx = dstr(wsx,wsu,dp[nd++],fw,fl,pc);
		when    'r':    wsx = rstr(wsx,wsu,dp[nd++],fw,fl,pc);
		when    'x':    wsx = lstr(wsx,wsu,"",fw,fl,pc);
		when    ZERO:   continue;
		default:        errmsg("<unknown format> '%c'\n",
							*tfx);
		}
		if(*tfx != ZERO)    tfx += 1;
	}
	else    *wsx++ = *tfx++;
	*wsx = ZERO;
/*
*/
	if(nr == BLINE)      hstr(ws,wsu,ws,x[nv].ll,fl,lc);
	if(ni >= 1)	{
		is[0] = WORD;
		is[1] = (char) ni;
		is[2] = STOP;
		strcpy(is+3,ws);
		}
	else	{
		strcpy(is,ws);
		}
/*
*/
	return(nr);
}
char	*
dstr(os,us,is,fw,fl,pc)             /* decimal tab */
char    *os,    *us,    *is;
{
	REG     char    *osx = os;
	REG     char    *usx = us;
	REG     char    *isx = is;
	auto    int     ls;
	auto    char    *apx = NULL;
	auto    char    *dpx = NULL;
	ls = strlen(is);
	fw = fw ? fw : ls;
	osx = strkat(osx,usx,isx);
	apx = strrchr(os,'.');
	if(apx == NULL) apx = os + strlen(os);
	dpx = os + fw - fl;
	strrev(os);
	while(osx < usx && apx < dpx)   {
		*osx++ = pc;
		ls += 1;
		apx += 1;
	}
	*osx = ZERO;
	strrev(os);
	while(osx < usx && ls++ < fw)   *osx++ = pc;
	*osx = ZERO;
	isx = os;
/*  replace blanks with pc */
	while(*isx != ZERO)
		if(*isx == ' ')     *isx++ = pc;
		else                ++isx;
	return(osx);
}
char    *
hstr(os,us,is,fw,fl,pc)             /* horizontal string */
char    *os,    *us,    *is;
{
	REG     char    *osx = os;
	REG     char    *usx = us;
	REG     int     tw = pws(is);
	tw = tw ? tw : fw;
/*
**  takes pseudo-table line and rewrites to horizontal
**  line of same length
*/
	while(osx < usx && tw-- >= 1)   *osx++ = pc;
	*osx = ZERO;
	return(osx);
}
char    *
lstr(os,us,is,fw,fl,pc)
char	*os;
char	*us;
char	*is;
int		fw;
int		fl;
int		pc;
{
	REG     unsigned	char    *osx = os;
	REG     unsigned	char    *isx = is;
	REG     			int     pw = 0;
/*  set limits */
	fw = fw >= 1 ? fw : pws(is);
	fl = fl >= 1 ? fl : fw;
	fl = fl >= fw ? fw : fl;
/*  truncate if long */
	while(osx < us && *isx != ZERO)
	if((pw += pwc(*isx)) <= fl) *osx++ = *isx++;
	else                        break;
/*  pad if int */
	while(osx < us && pw < fw)  {
		*osx++ = pc;
		pw += pwc(pc);
		}
	*osx = ZERO;
	if(osx >= us)   overflow(nv,"lstr",FUBAR);
	return(osx);
}
char    *
rstr(os,us,is,fw,fl,pc)             /* right adjsuted string */
char    *os,    *us,    *is;
{
	auto    char    *osx;
	strrev(is);
	osx = lstr(os,us,is,fw,fl,pc);
	strrev(os);
	return(osx);
}
char    *
cstr(os,us,is,fw,fl,pc)             /* centered string */
char    *os,    *us,    *is;
{
	REG     char    *osx = os;
	REG     char    *usx = us;
	REG     unsigned	char    *isx = is;
	REG     			int     hv = pws(is);   /* data width */
	REG     			int     lpd;            /* left pad */
	REG     			int     rpd;            /* right pad */
	fw = fw ? fw : hv;
	fl = fl > hv ? hv : fl;
	lpd = fw - fl;
	lpd = ((lpd - 1) / 2) + 1;
	rpd = fw - fl;
	rpd /= 2;
	while(osx < usx && lpd-- >= 1)  *osx++ = pc;
	while(osx < usx && *isx != ZERO && fl >= 1) {
		fl -= pwc(*isx);
		*osx++ = *isx++;
		}
	while(osx < usx && rpd-- >= 1)  *osx++ = pc;
	*osx = ZERO;
	if(osx >= usx)  overflow(nv,"cstr",FUBAR);
	return(osx);
}
xce(nv,is)
char    *is;
{
	if(x[nv].br >= 1 && x[nv].osx > x[nv].os)	xbr(nv,is);
	x[nv].br = 0;
	return(x[nv].ce = setvar(nv,is,ABSO,x[nv].ce,1));
}
zce(nv,is)          /* center a line */
char    *is;
{
	auto    char    ws[BLKSIZ];
	auto    int     pd;
	auto    int     pw;
	x[nv].ce -= 1;
	pw = pws(is);
	pd = (x[nv].lt + pw) / 2;
	rstr(ws,ws+BLKSIZ-1,is,pd,pd,' ');
	tblwrt(nv,ws);
	return(0);
}
xtl(nv,is)          /* three part title */
char    *is;
{
	auto    char    xs[BLKSIZ];
	auto    char    ws[BLKSIZ];
	auto    char    *wsx = ws;
	auto    char    *wsu = ws + BLKSIZ -1;
	auto    char    ps[16];         /* current page as a string */
	auto    char    *tp[4];
	auto    char    *ts;
	auto    int     pd = 0;
	auto    int     cf = x[nv].cf;
	auto    int     pf = x[nv].pf;
	while(trapat(nv,x[nv].vp))	;
	x[nv].cf = x[nv].pf = FOR;
/*  page number as string */
	itos(ps,x[nv].cp);
	strkat(xs,xs+BLKSIZ-1,is);
	mexpand(xs,xs+BLKSIZ-1);
	ts = wsx = subtforc(ws,wsu,xs,'%',ps) + 1;
/*  split */
	splitc(tp,4,ws,*ws);
	wsx = lstr(wsx,wsu,tp[0],0,0,'-');
	pd = x[nv].lt - pws(tp[0]) - pws(tp[2]);
	wsx = cstr(wsx,wsu,tp[1],pd,pws(tp[1]),' ');
	wsx = rstr(wsx,wsu,tp[2],0,0,' ');
	tblwrt(nv,ts);
	x[nv].cf = cf;
	x[nv].pf = pf;
	return(0);
}
char    *
subtforc(os,us,is,tc,ts)
char    *os, *us, *is, *ts;
{
	REG     char    *isx = is;
	REG     char    *osx = os;
	REG     char    *usx = us;
	while(osx < usx && *isx != ZERO)
	if(*isx == '\\' && isx[1] == tc)    {
		*osx++ = isx[1];
		isx += 2;
		}
	else
	if(*isx == tc)  {
		osx = strkat(osx,usx,ts);
		isx += 1;
		}
	else    *osx++ = *isx++;
	*osx = ZERO;
	if(osx >= usx)  overflow(nv,"subtforc",FUBAR); 
	return(osx);
}
xlt(nv,is)                  /* set title length */
char    *is;
{
	return(x[nv].lt = setvar(nv,is,VERT,x[nv].lt,DLT));
}
