#define			MULTI_VOL
#include 		<stdio.h>
#include		<ctype.h>
/**/
#ifdef			__TURBOC__
#define			CAN_PROTO
#include		<stdlib.h>		/* prototypes for common items */
#include		<sys/stat.h>
#include 		<fcntl.h>
#include		<time.h>
#endif
/**/
#ifdef 			MSDOS
#include 		<conio.h>
typedef	unsigned	ino_t;
#endif
/**/
#ifdef			M_XENIX
#define			CAN_PROTO
#include 		<sys/types.h>
#include		<sys/stat.h>
#include 		<fcntl.h>
#endif
/**/
#ifdef			SUN
#define			BSD
#endif			/*SUN*/
/**/
#ifdef			V42
#define			BSD
#endif			/*V42*/
/**/
#ifdef			BSD
#undef			CAN_PROTO
#include 		<sys/types.h>
#include		<sys/stat.h>
#include 		<fcntl.h>
#endif
/**/
#ifndef			TAR_EXTERN
#define			TAR_EXTERN	extern
#endif
/**/
/*DEFINE*/
#define		U2D		1
#define		D2U		2
#define	ZERO		0
#define	isodigit(c)	( ((c) >= '0') && ((c) <= '7') )
#ifndef	O_BINARY
#define	O_BINARY	0
#endif
#define	STDIN		0
#define	STDOUT		1
#define	T_DATA		0
#define	T_HEAD		1
#define	T_TAIL		2
#define	T_CRAP		3
#define	T_MORE		4
/* following items are in a series */
#define	M_RESTORE	1		/* restore mod times */
#define	M_NEWER		2		/* no extract if local newer */
#define	M_GENER		4		/* extract generations */
#define	M_UMASK		8		/* MSDOS 0755 mask OFF */
#define	T_EXTRACT	1
#define	T_CREATE	2
#define	T_LIST		4
#define	T_RAWIO		8
#define	T_OPEN		16
#define	T_CLOSE		32
#define	T_DISKS		64
#define	T_ATEND		128
#define	DOSUMASK	0755
/* end of series */
#define		ARG_GET		1
#define		ARG_REW		2
/**/
#define		WORK_OPEN	1
#define		WORK_CLOSE	2
#define		WORK_REWIND	3
/**/
#define		BIOS_RESET	0
#define		BIOS_STATUS	1
#define		BIOS_READ	2
#define		BIOS_WRITE	3
#define		BIOS_VERITY	4
#define		BIOS_FORMAT	5
#define	FUBAR		69
#define	RECORDSIZE	512
#define	BLKSIZ		RECORDSIZE
#define	NBUF		20		/* usual blocking factor */
#define	NBIP		(4096 / BLKSIZ)	/* pipes */
#define	NAMSIZ		100
#define	SLOP		10		/* number of blocks for cushion */
union record {
	char		charptr[RECORDSIZE];
	struct header {
		char	name[NAMSIZ];
		char	mode[8];
		char	uid[8];
		char	gid[8];
		char	size[12];
		char	mtime[12];
		char	chksum[8];
		char	linkflag;
		char	linkname[NAMSIZ];
#ifdef	MULTI_VOL
		char	extno[4];
		char	extotal[4];
		char	efsize[12];
#else
		char	magic[8];
		char	uname[TUNMLEN];
		char	gname[TGNMLEN];
		char	devmajor[8];
		char	devminor[8];
#endif
	} header;
};
/*TYPEDEF*/
typedef	struct 	OSWITCH {
	unsigned	convert		:	1;	/* convert times */
	unsigned	absnme		:	1;	/* strip absolute names */
	unsigned	archive		:	1;	/* make an archive */
	unsigned	capital		:	1;	/* capitalize directories */
	unsigned	copylink	:	1;	/* copy links under MSDOS */
	unsigned	diagno		:	4;	/* diagnostics */
	unsigned	estimate	:	1;	/* estimate disks needed */
	unsigned	extract		:	1;	/* extract from the archive */
	unsigned	listing		:	1;	/* listing of contents */
	unsigned	nottape		:	1;	/* not tape, can seek */
	unsigned	pathskip	:	5;	/* skip n parts of path */
	unsigned	rawio		:	1;	/* rawio for MSDOS */
	unsigned	recover		:	1;	/* recover bad files */
	unsigned	usemask		:	1;	/* use mask on MSDOS */
	unsigned	useperm		:	1;	/* use perms */
	unsigned	usetime		:	1;	/* use times from archive */
	unsigned	usenewr		:	1;	/* no extract if newer */
	unsigned	unhinge		:	1;	/* unlink after archiving */
	unsigned	usegenr		:	1;	/* extract generations */
	unsigned	pauseit		:	2;	/* pause before first disk */
	unsigned	verbose		:	3;	/* verbosity level */
	} 	OSWITCH;
typedef struct DEVICE {
	int		bif;		/* blocks in file */
	int		bpf;		/* blocks per floppy */
	int		bpr;		/* blocks per read */
	int		bpw;		/* blocks per write */
	int		cpo;		/* chars pending output */
	int		ctw;		/* characters to write */
	int		extno;		/* extant number */
	int		extotal;	/* number of extants */
	int		ifd;		/* input file descriptor */
	int		nbr;		/* number blocks read, last read */
	int		ofd;		/* output file descriptor */
	int		rawd;		/* raw drive */
	int		rbc;		/* read block counter */
	int		rbp;		/* read block pointer */
	int		wbc;		/* write block counter */
	int		wbp;		/* write block pointer */
	long	cif;		/* characters in file */
	long	efsize;		/* effective size of extant */
	}	DEVICE;
typedef unsigned 		NOSIGN;
typedef	struct	stat	STAT;
typedef	union 	record 	RECORD;
typedef	unsigned		BLOCKS;
typedef	long			FSIZE;
/* 
	The checksum field is filled with this while the checksum is computed.
*/
#define	CHKBLANKS	"        "	/* 8 blanks, no null */
/*
|	pdtar does not use the various link information below.  it is
|	here for reference only.
*/
/* 
	The magic field is filled with this if uname and gname are valid.
*/
#define	TMAGIC		"ustar  "	/* 7 chars and a null */
/* 
	The linkflag defines the type of file 
*/
#define	LF_OLD		'\0'	/* Normal disk file, Unix compat */
#define	LF_NOR		'0'		/* Normal disk file */
#define	LF_LIN		'1'		/* Link to previously dumped file */
#define	LF_SYM		'2'		/* Symbolic link */
#define	LF_CHR		'3'		/* Character special file */
#define	LF_BLK		'4'		/* Block special file */
#define	LF_DIR		'5'		/* Directory */
#define	LF_FIF		'6'		/* FIFO special file */
#define	LF_CON		'7'		/* Contiguous file */
/* 
	Further link types may be defined later.
*/
TAR_EXTERN	char	tmpdir[NAMSIZ];	/* temporary file directory */
TAR_EXTERN  DEVICE	device;		/* archive device attributes */
TAR_EXTERN  OSWITCH	oswitch;	/* option switches */
TAR_EXTERN	RECORD	curhead;	/* current header */
TAR_EXTERN	char	**argvect;	/* = argv */
TAR_EXTERN	STAT	whoami;		/* stat for archive */
TAR_EXTERN	STAT	*pwhoami;	/* pointer to whoami */
TAR_EXTERN	STAT	hstat;		/* header in stat format */
TAR_EXTERN	STAT	*phstat;	/* point to hstat */
TAR_EXTERN	char	afn[NAMSIZ];	/* archive name */
TAR_EXTERN	char	xfn[NAMSIZ];	/* index file (current) name */
TAR_EXTERN	FILE	*xfp;			/* index file list pointer */
TAR_EXTERN	char	lfn[NAMSIZ];	/* link file (current) name */
TAR_EXTERN	FILE	*lfp;			/* linked file list pointer */
TAR_EXTERN	FILE	*stdrpt;	/* report file pointer */
TAR_EXTERN	FILE	*stdask;	/* ask file pointer */
TAR_EXTERN	int		lf_typ;		/* archive type */
TAR_EXTERN	int		fun;		/* function */
TAR_EXTERN	int		nlinks;		/* number of linked files */
TAR_EXTERN	int		nsplit;		/* number of split files */
TAR_EXTERN	int		nfiles;		/* number of files */
TAR_EXTERN	int		ndisk;		/* number of disks */
TAR_EXTERN	int		(*rfunc)();	/* read function */
TAR_EXTERN	int		(*wfunc)();	/* write function */
TAR_EXTERN	int		numargs;	/* = argc */
TAR_EXTERN	int		argfile;	/* beginning of file names */
TAR_EXTERN	int		argsave;	/* beginning of file names */
TAR_EXTERN	char	rbuf[BLKSIZ * NBUF];		/* read buf */
TAR_EXTERN	char	f_rname[NAMSIZ];	/* file name (!massaged) */
TAR_EXTERN	char	l_rname[NAMSIZ];	/* link name (!massaged) */
TAR_EXTERN	char	f_name[NAMSIZ];		/* file name (massaged) */
TAR_EXTERN	char	l_name[NAMSIZ];		/* link name (massaged) */
