/*DOSLIB*/
/*UNXLIB*/
#define		DEBUG
#undef		DEBUG
/*
	changed to 5 line header and footer for conformity with pr
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		memnull(a,b)memset(a,0,b)
#define		TB			'\t'
#define		TS			8
#define		ROME		ZERO
#define		BOLD		DA
#define		UNDR		DB
#define		ITLC		DC
#define		HEADFOOT	10
/*EXTERNAL*/
#ifdef	CAN_PROTO
extern int stresc(char *);
extern int footer(char *, FILE *);
extern int header(char *, FILE *);
extern int kpr(int, char **);
extern char * sethead(char *);
extern int hint(int);
extern int rdfile(FILE *);
extern int segment(void);
extern int wrpage(FILE *);
extern char ** makeli(int,int);
extern char * strfnt(char *);
#else
extern int stresc();
extern int footer();
extern int header();
extern int kpr();
extern char * sethead();
extern int hint();
extern int rdfile();
extern int segment();
extern int wrpage();
extern char ** makeli();
extern char * strfnt();
#endif
/*GLOBAL*/
KENV		kenv;
char		*tstr;					/* header string */
int			pn = ZERO;				/* page number */
int			pl = 66;				/* page length */
int			co = 2;					/* columns */
int			ll = 60;				/* line length */
int			cw = 60;				/* column width */
long		skip = 0L;
long		quit = 0L;
long		line = 0L;
FUNCP		lfu;
char		**li;					/* lines */
char		ls[BUFSIZ];
char		ws[BUFSIZ];
char		fn[FNMSIZ];			/* segment file name */
int			sn = ZERO;			/* segment number */
typedef	struct	FONTS	{
	UCHAR	*fbeg;		/* begin font */
	int		lbeg;
	UCHAR	*fend;		/* end font */
	int		lend;
	int		fonto;		/* font is on or off */
	}	FONTS;
FONTS	fnt[] = {
	"\033E",2,"\033F",2,ZERO,		/* tj bold */
	"\033-1",3,"\033-0",3,ZERO,		/* tj under */
	"\033(s3B",5,"\033(s0B",5,ZERO,	/* lj bold */
	"\033(s0S",5,"\033(s1S",5,ZERO,	/* lj italic */
	"\033&dD",4,"\033&d@",4,ZERO,	/* lj under */
	}	;
/**/
int
stresc(is)		/* calculate line length */
char	*is;
{
	REG		UCHAR	*isx = is;
	REG		int		len = 0;
	auto	int		loop = BLKSIZ * 2;
/*
*	calculate line length making allowance for escape sequences.
*	an escape sequence is assumed to be
*	\033
*	
*/
	while(loop-- >= 1 && *isx != ZERO)
	if(*isx == '\033')	{
		isx += 1;
		switch(*isx)	{
			case	'E':	/* hp lj bold */
			case	'F':
							isx += 2;
							break;
			case	'U':	/* hp lj print direction */
			case	'-':	/* hp lj underline */
							isx += 3;
							break;
			case	' ':
			case	')':
			case	'(':
			case	'&':
							isx += 1;
/**/
							if(isalpha(*isx))		isx += 1;
/**/
#define		isnumbr(x)((isdigit(x) || x == '-' || x == '+' || x == '.')\
				? 1 : 0)
							while(isnumbr(*isx))	isx += 1;
/**/
							if(*isx == 'd')			isx += 2;
							else
							if(isalpha(*isx))		isx += 1;
							else
							if(*isx == '@')			isx += 1;
							break;
			default:		errmsg("stresc <bad sequence>\n");
							funxesc(isx-1,stderr);
							funxesc(is,stderr);
							exit(FUBAR);
			}
		}
	else
	if((*isx & 0177) >= ' ')		{
		isx += 1;
		len += 1;
		}
	else
	if(*isx == '\b')	{
		isx += 1;
		len -= 1;
		}
	else				{
		isx += 1;
		}
	if(loop <= ZERO)	{
		errmsg("stresc <loop broken>\n");
		exit(FUBAR);
		}
#ifdef	DEBUG
	fprintf(stderr,"len(%u) ",len);
	funxesc(is,stderr);
#endif
	return(len);
}
footer(is,fp)
FILE	*fp;
char	*is;
{
	fputs("\n\n\n\n\n",fp);
	return(ZERO);
}
header(is,fp)
char	*is;
FILE	*fp;
{
	auto	char	*fn;
	if(isnull(is))	is = "<stdin>";
	if(kenv.dosdos)	strxty(is,'\\','/');
	fn = strrchr(is,'/');
	if(!fn)	fn = is;
	fputs("\n\n",fp);
	fprintf(fp,"%s %s Page %d\n",tstr,fn,pn);
	fputs("\n\n",fp);
	return(ZERO);
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int	argc;
char	*argv[];
{
extern	int		kpr();
	kenv.dosdos = isdos();
	disnme(kenv.pname = "kpr");
	exit(cmdxrc(argc,argv,kpr,"kpr.xrc"));
}
kpr(argc,argv)
int		argc;
char	*argv[];
{
	setbuf(stdout,emalloc(bufsiz(),"main"));
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(cmdnum(argc,argv,'h',0,DA))			{
		exit(hint(0));
		}
/**/
	kenv.leisur = DA | DB;
	kenv.diagno = cmdnum(argc,argv,'D',0,DA);
	lfu = (FUNCP) stresc;
	co = cmdnum(argc,argv,'c',2,2);
	ll = cmdnum(argc,argv,'w',60,60);
	cw = ll/co;
	pl = cmdnum(argc,argv,'p',66,66);
	quit = cmdnum(argc,argv,'q',0,0);
	skip = cmdnum(argc,argv,'s',0,0);
	if(quit && quit <= skip)	{
		errmsg("<quit or skip spec bad>\n");
		exit(FUBAR);
		}
	if(kenv.flags0 = cmdnum(argc,argv,'t',0,DA))	{
		pl -= HEADFOOT;
		}
	li = makeli(pl,co);
#ifdef	USE_TABS
	kenv.flags1 = cmdnum(argc,argv,'T',0,DA);
#endif	USE_TABS
	kenv.flags3 = cmdnum(argc,argv,'L',0,DA);
/**/
	if(kenv.flags2 = cmdnum(argc,argv,'S',0,350))	{
		segment();
		}
	if(cmderr(argc,argv,"0123456789DqscwphtLST"))	{
		exit(hint(FUBAR));
		}
	sethead(NULL);
	dolist(argc,argv,rdfile);
	exit(0);
}
char	*
sethead(is)
char	*is;
{
	extern	char	*ctime();
	extern	long	time();
	auto	long	tnow;
	time(&tnow);
	tstr = strsave(strcnd(ctime(&tnow)));
	return(tstr);
}
hint(ty)
int   ty;
{
static	char	*hx[] = {
"=kpr [options] [file(s)]",
"*     formats the input file(s) to print in -cN columns per page.",
"*     HP Laser Jet and HP Think Jet escape sequences are recognized",
"*     to properly process bold, italic, and underline sequences.",
"=OPTIONS",
"-cN   number of columns [2]",
"-pNN  page length in lines [66]",
"-qnn  quit after nn lines",
"-SNN  segment output to files ./split???.tmp of NN kilobytes",
"-snn  skip nn input lines",
"-t    write a five line header and footer",
"-T    change sequences of 8 spaces to tabs",
"-wNN  width of page in characters [60]",
"=BUGS",
"*     unknown or improperly constructed escape sequences may cause",
"*     garbled output",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
}
int
rdfile(fp)
FILE	*fp;
{
	REG		int	lc = 0;
	REG		int	lx = pl * co;
	while(fgetlf(ls,ls+BLKSIZ-1,fp))	{
		line += 1;
		if(skip && line < skip)	continue;
		if(quit && line > quit)	break;
		strfnt(ls);
		if(lc >= lx)	{
			wrpage(stdout);
			lc = 0;
			}
		li[lc++] = strsave(ls);
		}
	wrpage(stdout);
	return(ZERO);
}
segment()	/* break up output file */
{
	auto	long	fs;
	auto	long	fx = (long) kenv.flags2 * 1024L;
	sprintf(fn,"./split%03d.tmp",sn);
	fs = filesize(fn);
	if(fs < 0L || fs >= fx)	{
		if(!freopen(fn,"w",stdout))	{
			prterr("<%s>",fn);
			exit(FUBAR);
			}
			sn += 1;
		}
	return(sn);
}
wrpage(fp)
FILE	*fp;
{
	REG		int	i;
	REG		int	j;
	REG		int	cwx;
	pn += 1;
	if(kenv.flags2)	segment();
	if(kenv.flags0)	header(getcfn(),fp);
	for(i = 0; i < pl; i += 1)	{
		for(j = i; j < co * pl; j += pl)	{
			if(li[j])	{
				fputs(li[j],fp);
				cwx = (*lfu)(li[j]);	/* needed spacing */
#ifdef	USE_TABS
				if(kenv.flags1)		{
					while((cw - cwx) >= TS)	{
						putc(TB,fp);
						cwx += TS;
						}
					}
#endif	USE_TABS
				if(kenv.flags3 & DA)	{	/* HP laser */
					fprintf(stdout,"\033&a+%dC",cw - cwx);
					}
				else	{
					while(cwx++ < cw)	{
						putc(' ',fp);
						}
					}
				free(li[j]);
				li[j] = NULL;
				}
			}
		fputs("\n",fp);
		}
	if(kenv.flags0)	footer(getcfn(),fp);
	return(ZERO);
}
char	**
makeli(pl,co)
int	pl;
int	co;
{
	auto	char		**rx;
	auto	unsigned	sz = (pl * co) * sizeof(char *);
	rx = (char **) malloc(sz);
	memnull( (char *) rx, sz );
	return(rx);
}
char	*
strfnt(is)		/* control fonts in line */
char	*is;
{
	REG		UCHAR	*isx = is;
	REG		int		i;
	auto	UCHAR	*wsx = ws;
	auto	UCHAR	*wsu = wsx + BLKSIZ - 1;
/* 	----	add font codes to beginning of line if needed */
	i = (sizeof(fnt)/sizeof(FONTS)) - 1;
	while(i >= 0)	{
		if(fnt[i].fonto & DA)	{
			wsx = strkat(wsx,wsu,fnt[i].fbeg);
			}
		i -= 1;
		}
/* 	----	look for font changes */
	while(*isx != ZERO)	{
	if(*isx == '\033')	{
		i = (sizeof(fnt)/sizeof(FONTS)) - 1;
		while(i >= 0)	{
			if(strncmp(isx,fnt[i].fend,fnt[i].lend) == 0) {
				fnt[i].fonto &= ~DA;
				break;
				}
			if(strncmp(isx,fnt[i].fbeg,fnt[i].lbeg) == 0) {
				fnt[i].fonto |= DA;
				break;
				}
			i -= 1;
			}
		}
	isx += 1;
	}
/* 	----	copy the line */
	wsx = strkat(wsx,wsu,is);
/* 	----	append cancellation codes */
	i = (sizeof(fnt)/sizeof(FONTS)) - 1;
	while(i >= 0)	{
		if(fnt[i].fonto & DA)	{
			wsx = strkat(wsx,wsu,fnt[i].fend);
			}
		i -= 1;
		}
/* 	----	rewrite the line */
	strcpy(is,ws);
	return(is);
}
