/*DOSLIB*/
/*UNXLIB*/
#define		USE_Z			/* code blanks as 'z' */
/*
 * uudecode [input]
 *
 * create the specified file, decoding as you go.
 * used with uuencode.
 */
/**/
#include 	<stdio.h>
#include 	<sys/types.h>
#include 	<sys/stat.h>
#ifndef		MSDOS
#include	<pwd.h>
#endif		/*MSDOS*/
/**/
#define		BIGBUF		10240
#define		ksetvbuf(a,b,c,d)setvbuf(a,c,b,d)
#ifdef		M_XENIX
#undef		ksetfbuf
#define		ksetvbuf(a,b,c,d)setvbuf(a,c,b,d)
#endif		/*M_XENIX*/
/**/
/* single character decode */
#define DEC(c)	(((c) - ' ') & 077)

void
terror(ty)
{
	exit(ty);
}
main(argc, argv)
char **argv;
{
	FILE *in, *out;
	struct stat sbuf;
	int mode;
	char dest[128];
	char buf[80];

	/* optional input arg */
	if (argc > 1) {
#ifdef	MSDOS
		if ((in = fopen(argv[1], "rb")) == NULL) {
#else
		if ((in = fopen(argv[1], "r")) == NULL) {
#endif
			perror(argv[1]);
			exit(1);
		}
#ifdef	SYSV
		ksetvbuf(in,NULL,_IOFBF,BIGBUF);
#endif	/*SYSV*/
		argv++; argc--;
	} else
		in = stdin;

	if (argc != 1) {
		auto	FILE	*ep = isatty(1) ? stdout : stderr;
		fprintf(ep,"Usage: uudecode [infile]\n");
		exit(2);
	}

	/* search for header line */
	for (;;) {
		if (fgets(buf, sizeof buf, in) == NULL) {
			auto	FILE	*ep = isatty(1) ? stdout : stderr;
			fprintf(ep, "No begin line\n");
			exit(3);
		}
		if (strncmp(buf, "begin ", 6) == 0)
			break;
	}
	sscanf(buf, "begin %o %s", &mode, dest);
#ifdef	MSDOS
#else	/*MSDOS*/
	/* handle ~user/file format */
	if (dest[0] == '~') {
		char *sl;
		struct passwd *getpwnam();
		char *index();
		struct passwd *user;
		char dnbuf[100];

		sl = index(dest, '/');
		if (sl == NULL) {
			auto	FILE	*ep = isatty(1) ? stdout : stderr;
			fprintf(ep, "Illegal ~user\n");
			exit(3);
		}
		*sl++ = 0;
		user = getpwnam(dest+1);
		if (user == NULL) {
			auto	FILE	*ep = isatty(1) ? stdout : stderr;
			fprintf(ep, "No such user as %s\n", dest);
			exit(4);
		}
		strcpy(dnbuf, user->pw_dir);
		strcat(dnbuf, "/");
		strcat(dnbuf, sl);
		strcpy(dest, dnbuf);
	}
#endif	/*MSDOS*/
	/* create output file */
#ifdef	MSDOS
	out = fopen(dest, "wb");
#else
	out = fopen(dest, "w");
#endif
	if (out == NULL) {
		perror(dest);
		exit(4);
	}
#ifdef	SYSV
	ksetvbuf(out,NULL,_IOFBF,BIGBUF);
#endif	/*SYSV*/
	chmod(dest, mode);

	decode(in, out);

	if (fgets(buf, sizeof buf, in) == NULL || strcmp(buf, "end\n")) {
		auto	FILE	*ep = isatty(1) ? stdout : stderr;
		fprintf(ep, "No end line\n");
		exit(5);
	}
	fprintf(stderr,"uudecode: %s\n",dest);
	exit(0);
}

/*
 * copy from in to out, decoding as you go along.
 */
decode(in, out)
FILE *in;
FILE *out;
{
	char buf[80];
	char *bp;
	int n;

	for (;;) {
		/* for each input line */
		if (fgets(buf, sizeof buf, in) == NULL) {
			auto	FILE	*ep = isatty(1) ? stdout : stderr;
			fprintf(ep,"Short file\n");
			exit(10);
		}
		n = DEC(buf[0]);
		if (n <= 0)
			break;

		bp = &buf[1];
		while (n > 0) {
			outdec(bp, out, n);
			bp += 4;
			n -= 3;
		}
	}
}

/*
 * output a group of 3 bytes (4 input characters).
 * the input chars are pointed to by p, they are to
 * be output to file f.  n is used to tell us not to
 * output all of them at the end of the file.
 */
outdec(p, f, n)
char *p;
FILE *f;
{
	int c1, c2, c3;

	c1 = DEC(*p) << 2 | DEC(p[1]) >> 4;
	c2 = DEC(p[1]) << 4 | DEC(p[2]) >> 2;
	c3 = DEC(p[2]) << 6 | DEC(p[3]);
	if (n >= 1)
		putc(c1, f);
	if (n >= 2)
		putc(c2, f);
	if (n >= 3)
		putc(c3, f);
}


/* fr: like read but stdio */
int
fr(fd, buf, cnt)
FILE *fd;
char *buf;
int cnt;
{
	int c, i;

	for (i=0; i<cnt; i++) {
		c = getc(fd);
#ifdef	USE_Z
		c = (c == 'z') ? ' ' : c;
#endif	/*USE_Z*/
		if (c == EOF)
			return(i);
		buf[i] = c;
	}
	return (cnt);
}

/*
 * Return the ptr in sp at which the character c appears;
 * NULL if not found
 */

#ifndef	NULL
#define	NULL	0
#endif	NULL

char *
index(sp, c)
register char *sp, c;
{
	do {
		if (*sp == c)
			return(sp);
	} while (*sp++);
	return(NULL);
}
